<template>
    <div>
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': errors && errors.length,
                'text-red-500': errors && errors.length,
                'font-black': boldLabel,
            }"
        >
            {{ label || name }}
        </label>
        <div class="mt-1 relative rounded-sm shadow-sm">
            <div :id="finalId" class="w-full" />
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="errors && errors.length"
        >
            <div
                v-for="(err, i) in errors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {inject, onMounted, ref, watch} from 'vue';
import EditorJS from "@editorjs/editorjs";
import Header from "@editorjs/header";
import Embed from "@editorjs/embed";
import Table from "@editorjs/table";
import Image from "@editorjs/image";
import List from "@editorjs/list";
import Paragraph from "@editorjs/paragraph";
import axios from "axios";

const props = defineProps({
    id: {
        required: false,
        type: [String, Number],
        default: null,
    },
    name: {
        required: true,
        type: [String, Number],
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    modelValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    errors: {
        required: false,
        type: Array,
        default: () => [],
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    },
    uploadImageUrl: {
        required: true,
        type: String
    }
});
let data = ref(props.modelValue);
const emit = defineEmits(['update:modelValue']);
const finalId = ref(null);
const editor = ref();

const $helper = inject('$helper');

watch(data, (newValue) => {
    emit('update:modelValue', newValue);
});

onMounted(() => {
    if (props.id) {
        finalId.value = props.id;
    } else {
        finalId.value = $helper.randomString(8);
    }

    let d;
    try {
        d = JSON.parse(data.value);
    } catch (e) {
        // console.log(e);
        d = {};
    }

    editor.value = new EditorJS({
        autofocus: true,
        holder: finalId.value,
        placeholder: props.placeholder,
        readOnly: props.readonly || props.disabled || false,
        tools: {
            header: {
                class: Header,
                inlineToolbar: true,
            },
            embed: Embed,
            table: {
                class: Table,
                inlineToolbar: true,
            },
            paragraph: {
                class: Paragraph,
                inlineToolbar: true,
            },
            image: {
                class: Image,
                config: {
                    uploader: {
                        async uploadByFile(file) {
                            let fd = new FormData();
                            fd.set('image', file);

                            try {
                                const data = await axios.post(props.uploadImageUrl, fd);

                                return {
                                    success: 1,
                                    file: {
                                        url: data.url
                                    }
                                };
                            } catch (e) {
                                console.log(e);
                            }
                        }
                    }
                },
                inlineToolbar: true,
            },
            list: {
                class: List,
                inlineToolbar: true,
            },
        },
        data: d,
        onChange: async (api, event) => {
            editor.value.save().then(async (outputData) => {
                data.value = outputData;
            });
        }
    });
});
</script>
